/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name :                                                          */
/*                                                                       */
/*       Date : March 4, 1998                                            */
/* Updated at : March 4, 1998                                            */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/** 
    1PX Crossover:
    1. let p1 and p2 be parents and m denote the number of columns 
    2. let c1 is the smallest index where p1 and p2 differs
    3. let c2 is the largest index where p1 and p2 differs
    4. randomly generate a number (k) in range [c1,c2]
    5. randomly generate a number (l) in range [c1,c2]
    5. let o1 = p1[1]...p1[k],p2[k+1],p2[k+2],...,p2[l],p1[l+1],,,,p1[m]
    6. let o2 = p2[1]...p2[k],p1[k+1],p1[k+2],...,p1[l],p2[l+1],,,,p2[m]
    7. repair o1 if necessary and reduce if it is possible
    8. repair o2 if necessary and reduce if it is possible

Note: Because of various repair strategy, repair will be overloaded.
*/
/*************************************************************************/

#ifndef _SCPCrossover2PX_h
#define _SCPCrossover2PX_h

#include <CrossOverOperation.h>
#include <Chromosomes.h>
#include <ChromosomesBag.h>

#include "SetCoverSolution.h"
#include "SCPCrossover1PX.h"


class SCPCrossover2PX : public SCPCrossover1PX
{
   public :
      SCPCrossover2PX();
      virtual ~SCPCrossover2PX();
      virtual ChromosomesBag apply(Chromosomes*,Chromosomes*);
      virtual ChromosomesBag applyOLD(Chromosomes*,Chromosomes*);
      virtual ChromosomesBag apply(Chromosomes*,Chromosomes*,float);

   private:

      virtual void repair(SetCoverSolution*);

};// end of Class SCPCrossover2PX

#endif

